/*
 *	main.c
 *
 *	MP3 Player
 *
 *	* Tue Oct 28 08:11:00 JST 2003 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "app.h"

//#define SPEED_TEST

/* I[gs[ggpꍇ́A
 * EQUICK_REPEAT_PADS`ĂB
 * EQUICK_REPEAT_PADSɍI[gs[gLɂPAD_*̑gݍ킹w肵ĂB
 * EQUICK_REPEAT_DELAYɍI[gs[gJn܂ł̎Ԃw肵ĂB
 * I[gs[ggpȂꍇ́A
 * EQUICK_REPEAT_PADS`ȂłB
 * EQUICK_REPEAT_PADS/DELAY̒`̗LɊւ炸AI[gs[g͍s܂B
 */
#define QUICK_REPEAT
#define QUICK_REPEAT_PADS	(PAD_LF | PAD_UP | PAD_RI | PAD_DN)
#define QUICK_REPEAT_DELAY	SEC(0.25)

/****************************************************************************
 *	萔E^
 ****************************************************************************/

#define FPS		20			/* t[[g */
#define SEC(s)		((int)(FPS * (s)))	/* b->t[ϊ */

typedef struct _MP3INFO {
	char fname[MAXFILENAME + 1];		/* t@C */
	int size;				/* t@CTCY */
} MP3INFO;

#define MAX_DISP	13			/* Sɕ\łt@C */

/****************************************************************************
 *	ϐ
 ****************************************************************************/

unsigned char vbuff[DISP_X * DISP_Y];	/* zVRAM */
SURFACE surface;			/* zVRAM̃T[tFCX */
RENDER render;				/* zVRAMւ̕` */

int draw;				/* ĕ`tO */
int now;				/* O[o^C} */
int joy;				/* pbh */

MP3INFO mp3_info[MAXDIR];		/* MP3t@CXg */
int mp3_count;				/* MP3t@C̐   */
int cursel;				/* ݂̑It@CCfNX */
int curtop;				/* ŏi\t@CCfNX */
int curplay = -1;			/* Đt@CCfNX */

/****************************************************************************
 *	֐錾
 ****************************************************************************/

void err_disp(const char* fmt, ...);
void app_init();
void app_exit();
void schedule();
void run();

/****************************************************************************
 *	main
 ****************************************************************************/

int
main()
{
	/* B */
	app_init();

	/* C[vB */
	run();

	return 0;
}

/****************************************************************************
 *	err_disp
 ****************************************************************************/

void
err_disp(const char* fmt, ...)
{
	int len, x, y;
	char str[100]; /* ꂮ炢Ώ[H */
	va_list ap;

	va_start(ap, fmt);
	len = vsprintf(str, fmt, ap);
	va_end(ap);

	x = (DISP_X - 5 * len) / 2;
	y = (DISP_Y - 10) / 2;
	memset(vbuff, 0, sizeof vbuff);
	render_string(&render, x, y, str, 0x80, 3);
	draw = 1;
	for(;;) {
		schedule();
		if(joy & (TRG_A | TRG_B | TRG_START | TRG_SELECT)) break;
	}
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

static int
mp3_info_compare(const void* _a, const void* _b)
{
	MP3INFO* a = (MP3INFO*)_a;
	MP3INFO* b = (MP3INFO*)_b;
	return strcmp(a->fname, b->fname);
}

void
app_init()
{
	int retval, len;
	FILEINFO fi;
	MP3INFO* mi;

	/* ʓIȏB */
	pceLCDDispStop();
	pceLCDSetBuffer(vbuff);
	pcePadSetTrigMode(PP_MODE_SINGLE);
	pceLCDDispStart();

	/* `B */
	surface.w = DISP_X;
	surface.h = DISP_Y;
	surface.vbuff = vbuff;
	render_init_2d(&render, &surface, 0, 0, 0, 0);

	/* N[Abv֐o^B */
	atexit(app_exit);

	/* MP3t@CT܂B */
	memset(mp3_info, 0, sizeof mp3_info);
	mp3_count = 0;
	mi = &mp3_info[0];
	retval = pceFileFindOpen(&fi);
	if(retval != 0) DIE();
	while(mp3_count < MAXDIR) {
		retval = pceFileFindNext(&fi);
		if(!retval) break; /* t@CȂ */
		/* gq".mp3"łȂ΁A΂܂B */
		len = strlen(fi.filename);
		if(len < 4) continue;
		if(strcasecmp(&fi.filename[len - 4], ".mp3") != 0) continue;
		/* t@CƃTCYi[܂B */
		if(len > MAXFILENAME) DIE();
		memcpy(mi->fname, fi.filename, len);
		mi->size = fi.length;
		mp3_count++;
		mi++;
	}
	pceFileFindClose(&fi);
	if(mp3_count == 0) {
		err_disp("MP3t@C܂");
		exit(0);
	}

	/* t@CɃ\[gB */
	qsort(mp3_info, mp3_count, sizeof(MP3INFO), mp3_info_compare);

	/* S48MHz[hB */
	turbo(1);
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

void
schedule()
{
#ifdef QUICK_REPEAT
	static unsigned char rep[8]; /* I[gs[gJE^ */
#endif /*QUICK_REPEAT*/

	int x, y;

	/* ɃX^oCɗȂ悤ɁB */
	pceAppActiveResponse(AAR_ACTIVE);

	/* drcʕ\XV̂߁AʍXVvȂĂAb1͋ʍXVB */
	if(now % SEC(1) == 0) {
		draw = 1;
	}

	/* ʍXVB */
	if(draw) {
		pceLCDTrans();
		draw = 0;
	}

	/* VXeB */
	yield();

	/* pbhԍXVB */
	joy = pcePadGet();

	/* O[o^C}XVB */
	now++;

#ifdef QUICK_REPEAT
	/* I[gs[gB */
	for(x = 0; x < 8; x++) {
		y = 1 << x; /* PAD_* */
		if(QUICK_REPEAT_PADS & y) {
			if(joy & y) {
				if(rep[x] != 0xff) rep[x]++;
				if(rep[x] >= QUICK_REPEAT_DELAY) joy |= y << 8; /* TRG_* */
			} else {
				rep[x] = 0;
			}
		}
	}
#endif QUICK_REPEAT
}

/****************************************************************************
 *	run
 ****************************************************************************/

void
run()
{
#ifndef SPEED_TEST /*********************************************************/

	int retval, i, y, c, i_mp3, len;
	const void* romp;
	MP3INFO* mi;

	goto L10; /* ͋` */
	for(;;) {
		schedule();

		/* pbh͂Ȃ΁A܂B */
		if(!joy) continue;

		/* IH */
		if(joy & TRG_SELECT) {
			exit(0);
		}

		/* t@CIύXH */
		if(joy & TRG_UP && cursel > 0             ) cursel--;
		if(joy & TRG_DN && cursel < mp3_count - 1) cursel++;
		if(joy & TRG_LF) {
			cursel -= MAX_DISP;
			if(cursel < 0) cursel = 0;
		}
		if(joy & TRG_RI) {
			cursel += MAX_DISP;
			if(cursel > mp3_count - 1) cursel = mp3_count - 1;
		}
		if(cursel < curtop                 ) curtop = cursel                 ;
		if(cursel > curtop + (MAX_DISP - 1)) curtop = cursel - (MAX_DISP - 1);

		/* ĐJnH */
		if(joy & TRG_A) {
			mp3_stop(); /* t@C񒆂̃mCY}邽߁AIɒ~ */
			mi = &mp3_info[cursel];
			romp = file_defrag(mi->fname, &len);
			retval = mp3_play(romp, len); /* 48MHzE1WAIT[hɂȂ܂ */
			if(retval == 0) {
				curplay = cursel;
			} else {
				err_disp("Đł܂ł");
				/* p */
			}
		}

		/* Đ~H */
		if(joy & TRG_B) {
			mp3_stop();
			curplay = -1;
		}

L10:
		/* t@CXg\B */
		memset(vbuff, 0, sizeof vbuff);
		mi = &mp3_info[curtop];
		y = 8;
		for(i = 0; i < MAX_DISP + 1/*ɏ镪`*/; i++) {
			i_mp3 = curtop + i;
			if(i_mp3 > mp3_count - 1) break;
			if(i_mp3 == cursel) {
				if(i_mp3 == curplay) {
					render_rectangle_fill(&render, 0, y - 1, DISP_X, 6 + 1, 1);
					c = 3;
				} else {
					render_rectangle_fill(&render, 0, y - 1, DISP_X, 6 + 1, 2);
					c = 0;
				}
			} else {
				if(i_mp3 == curplay) {
					c = 3;
				} else {
					c = 2;
				}
			}
			render_string(&render, 4 + 4 *  1, y, mi->fname, 0x82, c);
			render_printf(&render, 4 + 4 * 15, y, 0x82, c, "%8d bytes", mi->size);
			mi++;
			y += 6;
		}

		/* ^Cg\Biɂ͂ݏot@CXgɏ㏑j */
		render_rectangle_fill(&render, 0, 0, DISP_X, 6 + 1, 3);
		render_string(&render, 0, 1,
		//       0123456789012345678901234567890123
			"=========== MP3 Player ===========",
			0x82, 0);

		/* ʓ]B */
		draw = 1;
	}

#else	/********************************************************************/

	static MP3DRIVER mp3;

	int i, len, T0, T1;
	const void* romp;

	romp = file_defrag("mariel.mp3", &len);
	if(mp3_init(&mp3, romp, len)) DIE();
	T0 = pceTimerGetCount();
	i = 0;
	for(;;) {
		i += mp3.c_fbuff;
		if(i >= 16000 * 10) break;
		mp3_decode_frame(&mp3);
	}
	T1 = pceTimerGetCount();
	for(;;) {
		schedule();
		surface_clear(&surface, 0);
		render_printf(&render, 0, 0, 0x80, 3, "%d", T1 - T0);
	}

#endif	/********************************************************************/
}
